function [beta,stat] = beta_marg_norm_rnd(C_0,C_1,h_vec,H_mat,size_b,r,Omega,alpha,cu_symmetric)

cov_mat = kron(alpha'*inverse(Omega)*alpha,C_1);
mean_vec = vec(C_0'*inverse(Omega)*alpha);

cov_mat_b_inv = cov_mat;
[test_mat,stat] = chol(cov_mat);
if stat>0;
   beta = [];
   return;
end;
cov_mat = inverse(cov_mat);
mean_vec = cov_mat*mean_vec;

%
% now we transform this mean and covariance into psi rather than vec(beta)
%

cov_mat_psi = inverse((H_mat'*cov_mat_b_inv*H_mat));
mean_vec = cov_mat_psi*H_mat'*cov_mat_b_inv*(mean_vec-h_vec);

[std_mat,stat] = chol(cov_mat_psi);
if stat>0;
   beta = [];
   return;
end;

if cu_symmetric==1;
   std_mat = symm(cov_mat_psi);
end;

psi = mean_vec+(std_mat'*randn(size(mean_vec,1),1));
beta_vec = h_vec+(H_mat*psi);
beta = vecinv(beta_vec,size_b);

%
% end of beta_marg_norm_rnd.m
%
