function center_fill_figure(fig,my_fill_value,my_center_value)

if strcmp(get(fig,'PaperPositionMode'),'auto')==1;
   return;
end;

old_paper_units = get(fig,'PaperUnits');
set(fig,'PaperUnits','points');
paper_size = get(fig,'PaperSize');
paper_position = get(fig,'PaperPosition');

if my_fill_value==1;
   new_paper_position = [0 0 paper_size];
elseif my_fill_value==2;
   new_paper_position = [(1/4)*paper_size (1/2)*paper_size];
elseif my_fill_value==3;
   new_paper_position = [(1/3)*paper_size (1/3)*paper_size];
elseif my_fill_value==4;
   new_paper_position = [(3/8)*paper_size (1/4)*paper_size];
elseif my_fill_value==5;
   new_paper_position = [(9/20)*paper_size (1/10)*paper_size];
else;
   new_paper_position = paper_position;
end;

paper_position = new_paper_position;

if my_center_value==1;
   new_left = (paper_size(1)-paper_position(3))/2;
   new_bottom = (paper_size(2)-paper_position(4))/2;
   new_paper_position = [new_left new_bottom paper_position(3:4)];
%
% check if lower left
%
elseif my_center_value==2;
   new_paper_position = [0 0 paper_position(3:4)];
%
% check if lower right
%
elseif my_center_value==3;
   new_paper_position = [paper_size(1)-paper_position(3) 0 paper_position(3:4)];
%
% check if upper left
%
elseif my_center_value==4;
   new_paper_position = [0 paper_size(2)-paper_position(4) paper_position(3:4)];
%
% check if upper right
%
elseif my_center_value==5;
   new_paper_position = [paper_size(1)-paper_position(3) paper_size(2)-paper_position(4) paper_position(3:4)];
end;

set(fig,'PaperPosition',new_paper_position);
set(fig,'PaperUnits',old_paper_units);

%
% end of center_fill_figure.m
%
