function [pos,bplot] = contour_plot(pos,fig_tag,fig_name,p_title,x_label,y_label,tm,curr_ini,as_mat_fixed,x_n,y_n,n1,fix_ax_pos)

%
% find limits using cdf2d
%
pc = [80,90,95,98,99];
ddata = kdint2([as_mat_fixed(:,2) as_mat_fixed(:,1)],x_n,y_n,n1); 
wt = pclevel(pc,ddata);
%
bplot = figure('Units','pixels', ...
   'Position',[pos 600 400], ...
   'NumberTitle','off', ...
   'Menubar','none', ...
   'Toolbar','none', ...
   'Tag',fig_tag, ...
   'Visible','off', ...
   'Name',fig_name);
%
pos = [pos(1)+22 pos(2)-22];
if pos(1,1)>(tm.realscrsz(3)-600);
   pos = [0 tm.realscrsz(4)-470];
end;
if pos(1,2)>(tm.realscrsz(4)-470);
   pos = [0 tm.realscrsz(4)-470];
elseif pos(1,2)<32;
   pos = [0 tm.realscrsz(4)-470];
end;
%
% obey centering and filling defaults
%
setfigureproperties(bplot);
%
% plotting zero lines if there are any
%
if (min(x_n)<0)&(max(x_n)>0);
   plot([0 0],[min(y_n) max(y_n)],'LineWidth',1,'Color',[0 0 0],'LineStyle','-');
   hold('on');
end;
if (min(y_n)<0)&(max(y_n)>0);
   plot([min(x_n) max(x_n)],[0 0],'LineWidth',1,'Color',[0 0 0],'LineStyle','-');
   hold('on');
end;
%
% setting up the contour lines
%
if curr_ini.colors==1;
   c_vec = [1 0 0;
            0 0 1;
            1 0.5 0;
            0 0.75 0;
            0 0 0];
else;
   c_vec = [0.7 0.7 0.7;
            0.6 0.6 0.6;
            0.5 0.5 0.5;
            0.4 0.4 0.4;
            0.3 0.3 0.3];
end;
l_style = strvcat('--',':','-','-.',':');
my_leg_objects = [];
%
for i1=1:length(pc);
   [c_mat,l_handles] = contour(x_n,y_n,n1,wt(i1,:),'-');
   num_h = size(l_handles,1);
   for j1=1:num_h;
      if j1==1;
         my_leg_objects = [my_leg_objects l_handles(j1)];
         set(l_handles(j1),'Tag',['legline-' num2str(i1) '.' num2str(j1)],'Color',c_vec(i1,:),'LineStyle',strtrim(l_style(i1,:)),'LineWidth',1);
      else;
         set(l_handles(j1),'Tag',['2dlines-' num2str(j1)],'Color',c_vec(i1,:),'LineStyle',strtrim(l_style(i1,:)),'LineWidth',1);
      end;
   end;
   if i1==1;
      hold('on');
   end;
end;
%
% taking care of limits
%
this_axes = gca;
set(this_axes,'XLim',[min(x_n) max(x_n)]);
set(this_axes,'YLim',[min(y_n) max(y_n)]);
%
% setting default values for figure
%
setaxesfonts('Title',p_title,'XLabel',x_label,'YLabel',y_label);
%if fix_ax_pos==1;
%   old_ax_units = get(this_axes,'Units');
%   set(this_axes,'Units','pixels');
%   ax_pos = get(this_axes,'Position');
%   set(this_axes,'Position',ax_pos-[0 0 0 10]);
%   set(this_axes,'Units',old_ax_units);
%end;
if size(my_leg_objects,2)>=5;
   myleg = legend_fcn(my_leg_objects,strvcat('80%','90%','95%','98%','99%'),0);
   setaxesfonts(myleg);
   myleg = update_legend(myleg);
   set(this_axes,'UserData',myleg);
end;
toolbar_fcn(this_axes);
hold('off');

%
% end of contour_plot.m
%
