function [alpha_n,Psi_n,beta_n,Omega_n,epsilon_n,Sigma_theta_n,Psi_f] = estimate_longrun_dummies(Z0,Z1,Z2,num_const,lr_dummies,r,dcoint,q1,p,pe,d,q0,restrict,modelsdir,modelfile,reestbeta)

%
%
[n T] = size(Z0);
%
% prepare Z1 and Z2
%
Z2_lrd = Z2(lr_dummies+num_const,:);
all_z2 = (1:1:size(Z2,1));
use_z2 = setdiff(all_z2,lr_dummies+num_const);
if isempty(use_z2)==0;
   Z2_lr = Z2(use_z2,:);
else;
   Z2_lr = [];
end;
Z1_lr = [Z1;Z2_lrd];
%
% create restrictions files for beta if necessary
%
if restrict(1,2)==1;
   file_norm = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.norm');
   if fileexist(file_norm)==1;
      norm_vec = loaddata(file_norm);
   else;
      norm_vec = (1:1:r)';
   end;
   file_norm_new = strcat(modelsdir,'normalize-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+size(lr_dummies,2)),'-',modelfile,'.norm');
   if fileexist(file_norm_new)==1;
      file_norm_cp = [file_norm_new '.bak'];
      rename_file_fcn(file_norm_new,file_norm_cp);
   end;
   %
   % save the normalisations
   %
   fid = fopen(file_norm_new,'wt');
   fprintf(fid,'%0.0f\n',norm_vec');
   fclose(fid);
   for i=1:r;
      file = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1),'-',modelfile,'.rest');
      if fileexist(file)==1;
         h = loaddata(file);
         h = [h zeros(size(h,1),size(lr_dummies,2));zeros(size(lr_dummies,2),size(h,2)) eye(size(lr_dummies,2))];
         file_new = strcat(modelsdir,'H_',num2str(i),'-',num2str(n),'x',num2str(r),'x',num2str(dcoint+q1+size(lr_dummies,2)),'-',modelfile,'.rest');
         if fileexist(file_new)==1;
            %
            % create a backup copy of the original
            %
            file_cp = [file_new '.bak'];
            rename_file_fcn(file_new,file_cp);
         end;
         fid = fopen(file_new,'wt');
         prt_str = '';
         for j=1:size(h,2);
            prt_str = [prt_str ' %2.4f'];
         end;
         fprintf(fid,[prt_str '\n'],h');
         fclose(fid);
      else;
         restrict(1,2)==0;
      end;
   end;
end;

%
% estimate model under the null hypothesis
%
[S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_n,lambda,my_trace] = mlcointbasic(Z0,Z1_lr,Z2_lr,r);
%
if restrict(1,2)==1;
   [beta_n,newlambda,newdfbeta,stdbeta,outputtxt,new_abort] = betarestrict(S_00,S_11,S_01,S_10,beta_n,T,modelsdir,modelfile,0,dcoint);
end;
alpha_n = (S_01*beta_n)*inverse(beta_n'*S_11*beta_n);
if isempty(Z2_lr)==0;
   Psi_n = (M_02*inverse(M_22))-(alpha_n*beta_n'*M_12*inverse(M_22));
   epsilon_n = Z0-(alpha_n*beta_n'*Z1_lr)-(Psi_n*Z2_lr);
   Z3 = [Z2_lr;beta_n'*Z1_lr];
else;
   Psi_n = [];
   epsilon_n = Z0-(alpha_n*beta_n'*Z1_lr);
   Z3 = beta_n'*Z1_lr;
end;
%
% compute an estimate of Sigma_theta_n
%
Omega_n = (1/T)*epsilon_n*epsilon_n';
Sigma_theta_n = kron(inverse(Z3*Z3'),Omega_n);
%
% estimate under alpha restrictions
%
Theta_n = [Psi_n alpha_n];
if restrict(1,1)==1;
   %
   % retrieve the restrictions on alpha
   %
   file = strcat(modelsdir,'G-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
   G = loaddata(file);
   [Rmat,rvec] = rmatrix(G,n,r);
   dfalpha = size(G,1);
   if isempty(Z2_lr)==0;
      Rmat = [zeros(dfalpha,size(Z2_lr,1)*n) Rmat];
   end;
   if reestbeta==0;
      [theta_n,Sigma_theta_n,infomat,newabort] = linrest(Z0,Z3,Theta_n,Rmat,rvec,0);
   else;
      [theta_n,Sigma_theta_n,beta_n,newstdbeta,Z3,infomat,newabort] = alpha_beta_restrict(Z0,Z1_lr,Z2_lr,Z3,beta_n,Theta_n,Rmat,rvec,dcoint+size(lr_dummies,2),q1,modelsdir,modelfile,0);
   end;
   g2 = size(theta_n,2);
   alpha_n = theta_n(:,g2-r+1:g2);
   if g2>r;
      Psi_n = theta_n(:,1:g2-r);
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_lr)-(Psi_n*Z2_lr);
   else;
      Psi_n = [];
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_lr);
   end;
   Omega_n = (1/T)*epsilon_n*epsilon_n';
end;
%
% estimate under C restrictions
%
if (size(restrict,2)==3)&(restrict(1,3)==1);
   file = strcat(modelsdir,'C-',int2str(n),'x',int2str(r),'-',modelfile,'.rest');
   G = loaddata(file);
   [Rmat_C,rvec_C] = rmatrix(G,n,n);
   %
   [theta_n,Sigma_theta_n,beta_n,stdbeta,C_n,Sigma_C,num_c_rest,num_a_rest,infomat,newabort] = c_restrict(Z0,Z1_lr,Z2_lr,restrict,beta_n,[Psi_n alpha_n],Rmat_C,rvec_C,p,pe,d-size(lr_dummies,2),dcoint+size(lr_dummies,2),q0,q1,modelsdir,modelfile,0);
   %
   g2 = size(theta_n,2);
   alpha_n = theta_n(:,g2-r+1:g2);
   if g2>r;
      Psi_n = theta_n(:,1:g2-r);
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_lr)-(Psi_n*Z2_lr);
   else;
      Psi_n = [];
      epsilon_n = Z0-(alpha_n*beta_n'*Z1_lr);
   end;
   Omega_n = (1/T)*epsilon_n*epsilon_n';
end;

%
% create a Psi matrix corresponding to Z2 rather than Z2_lr
%

Psi_f = zeros(n,size(Z2,1));
num = 1;
for i=1:size(Z2,1);
   f = sum(i~=lr_dummies+num_const);
   if f==size(lr_dummies,2);
      Psi_f(:,i) = Psi_n(:,num);
      num = num+1;
   end;
end;

Psi_add = alpha_n*beta_n(n+q1+dcoint+1:n+q1+dcoint+size(lr_dummies,2),:)';

for i=1:size(lr_dummies,2);
   f = lr_dummies+num_const;
   Psi_f(:,f(1,i)) = Psi_add(:,i);
end;

%
% end of estimate_longrun_dummies.m
%
