function g_phi = grad_phi(B,beta,Omega,epsilon,Z1,Z2,S,r,normval)

if nargin<9;
   normval = 0;
end;

%
% return an (n+k)*n x 1 vector
%

n = size(B,1);
T = size(epsilon,2);
%Omega = B*B';
Omega_inv = Omega\eye(n);

Z = [];
if r>0;
   Z = beta'*Z1;
end;
Z = [Z2;Z];
k = size(Z,1);

Nn = ncommutation(n);
diff_Omega = (Omega_inv*epsilon*epsilon')-(T*eye(n));

g_phi = ([vec(epsilon*Z')'*kron(eye(k),Omega_inv) vec(eye(n))'*kron(diff_Omega,Omega_inv)*Nn*kron(B,eye(n))]*S)';
if normval==1;
   g_phi = (1/T)*g_phi;
end;

%
% end of grad_phi.m
%
