function lpr = logprior_beta(delta,Gamma,Omega,alpha,beta,n,r,d,prior_inf_deter,prior_inf_alpha,prior_inf_omega,A,q,lambda_alpha,d_mu,d_sigma,G_mu,G_sigma)

%
% computes the value of the density function for the joint prior when investigating the cointegration rank
%

lpr = 0;
if (d>0)&(prior_inf_deter==1);
   lpr = log_normal(delta,vecinv(d_mu,n),d_sigma,Omega);
%   lpr = log_norm(vec(delta),d_mu,kron(d_sigma,Omega));
end;
if isempty(G_mu)==0;
   lpr = lpr + log_normal(Gamma,vecinv(G_mu,n),G_sigma,Omega);
%   lpr = lpr + log_norm(vec(Gamma),G_mu,kron(G_sigma,Omega));
end;
if (prior_inf_alpha==1)&(prior_inf_omega==1);
   %
   % take care of the rest
   %
   log_cr = ((q/2)*log(det(A))) - (((n*q)/2)*log(2)) - (((n*(n-1))/4)*log(pi)) - (((r*(n-r))/2)*log(pi)) - (((n*r)/2)*log(2*pi*(lambda_alpha^2))) - gamma_product(n,q);
   log_cr = log_cr - gamma_product(r,n) - gamma_product(r,r);
   add_mat = (1/(lambda_alpha^2))*alpha*beta'*beta*alpha';
   %
   log_pa = -(((n+r+q+1)/2)*log(det(Omega))) - ((1/2)*sum(diag( inverse(Omega)*( A + add_mat ) )));
   lpr = lpr+log_cr+log_pa;
elseif (prior_inf_alpha==2)&(prior_inf_omega==2);
   lpr_omega = -((n+1)/2)*log(det(Omega));
   lpr_ab = -(n/2)*log(det(beta'*beta));
   lpr = lpr+lpr_omega+lpr_ab;
elseif (prior_inf_alpha==1)&(prior_inf_omega==2);
   lpr_omega = -((n+1)/2)*log(det(Omega));
   lpr_b = -(n/2)*log(det(beta'*beta));
   lpr_a = log_normal(alpha,zeros(n,r),(lambda_alpha^2)*inverse(beta'*beta),Omega);
%   lpr_a = log_norm(vec(alpha),zeros(n*r,1),kron(inverse(beta'*beta),(lambda_alpha^2)*Omega));
   lpr = lpr+lpr_omega+lpr_b+lpr_a;
elseif (prior_inf_alpha==2)&(prior_inf_omega==1);
   log_cr = ((q/2)*log(det(A))) - (((n*q)/2)*log(2)) - (((n*(n-1))/4)*log(pi)) - (((r*(n-r))/2)*log(pi)) - gamma_product(n,q);
   log_cr = log_cr - gamma_product(r,n) - gamma_product(r,r);
   log_bom = -(((n+q+1)/2)*log(det(Omega))) - ((1/2)*sum(diag(inverse(Omega)*A))) - ((n/2)*log(det(beta'*beta)));
   lpr = lpr+log_cr+log_bom;
end;

%
% end of logprior_beta.m
%
