function [out,m_v,curr_ini] = main_store_fcn(out,m_v,curr_ini,fig)

mystore = 1;
if fileexist(m_v.inputfile)==1;
   answer = query('Would you like to save the model in a new model file?','question',120,'Structural VAR - Save As',350,'no');
else;
   answer = 'Yes';
end;
if strcmp(answer,'Yes');
   mypwd = pwd;
   if strcmp(mypwd(1,1),'/')==1;
      thispath = strcat(m_v.basedir,'/');
   else;
      thispath = strcat(m_v.basedir,'\');
   end;
   inputfiletype = strcat(thispath,'*.var');
   if ispc==1;
      inputfiletype = strcat(thispath,getname(m_v.inputfile),'.var');
   end;
   [savefile,savepath] = uiputfile(inputfiletype, 'Save As');
   drawnow;
   if isnumeric(savefile)==0;
      %
      % append .var if left out or change used
      % file extension to .var if another is
      % used
      %
      if strcmp(getext(savefile),'.var')==1;
         savefile = [getname(savefile) '.var'];
      else;
         savefile = [savefile '.var'];
      end;
      m_v.nameinput = [' - ' savefile];
      set(fig,'Name',['Structural VAR - ' savefile]);
      newinputfile = strcat(savepath,savefile);
      set(out.open,'UserData',newinputfile);
      set(out.reorderlist,'Enable','on');
      %
      % Delete objects in file list
      %
      thish = findobj('Type','uimenu','Callback','maindlg reopen')';
      if isempty(thish)==0;
         delete(thish);
      end;
      %
      % Fix file lists
      %
      if strcmp(newinputfile,'')==0;
         if isempty(findstr(newinputfile,curr_ini.reopenlist))==1;
            if size(m_v.reopenfile,1)>=10;
               myreopenfile = m_v.reopenfile(10,:);
               if strcmp(strrep(myreopenfile,' ',''),savefile)==0;
                  m_v.reopenfile = m_v.reopenfile(1:9,:);
               else;
                  m_v.reopenfile = strvcat(m_v.reopenfile(1:8,:),m_v.reopenfile(10,:));
               end;
%                        curr_ini.reopenlist = invlist(m_v.reopenfile);
            end;
            m_v.reopenfile = strvcat(newinputfile,m_v.reopenfile);
            curr_ini.reopenlist = [newinputfile '|' curr_ini.reopenlist];
         end;
      end;
      %
      % recreate objects in file list menu
      %
      num = 1;
      for i=1:size(m_v.reopenfile,1);
         thisfile = strtrim(m_v.reopenfile(i,:));
         if strcmp(newinputfile,thisfile)==0;
            if num==1;
               out.thisfile = uimenu('Parent',out.reopen, ...
                  'Label',['&1. ' getfilename(thisfile)], ...
                  'Callback','maindlg reopen', ...
                  'Accelerator','1', ...
                  'Separator','on', ...
                  'UserData',thisfile, ...
                  'Tag',['1-' getfilename(thisfile)]);
            else;
               if num<10;
                  out.thisfile = uimenu('Parent',out.reopen, ...
                     'Label',['&' num2str(num) '. ' getfilename(thisfile)], ...
                     'Callback','maindlg reopen', ...
                     'Accelerator',num2str(num), ...
                     'UserData',thisfile, ...
                     'Tag',[num2str(num) '-' getfilename(thisfile)]);
               else;
                  out.thisfile = uimenu('Parent',out.reopen, ...
                     'Label',['1&0. ' getfilename(thisfile)], ...
                     'Callback','maindlg reopen', ...
                     'Accelerator','0', ...
                     'UserData',thisfile, ...
                     'Tag',['10-' getfilename(thisfile)]);
               end;
            end;
            num = num+1;
         end;
      end;
   else;
      mystore = 0;
   end;
end;
if mystore==1;
   m_v.newp = get(out.mypopup,'Value');
   m_v.lagexo = get(out.lagexo,'Value')-1;
   m_v.newh = get(out.mypopuph,'Value');
   m_v.newc = get(out.mypopupc,'Value');
   m_v.endofile = get(out.endogenous,'String');
   if isempty(m_v.modelsdir);
      m_v.modelsdir = get(out.endogenous,'UserData');
   end;
   if strcmp(m_v.modelsdir,'')==1;
      if curr_ini.dirstructure==0;
         m_v.modelsdir = getpath(m_v.outputfile);
         mysize = size(m_v.modelsdir,2);
         mymodelsdir1 = m_v.modelsdir(1,1:mysize-8);
         mymodelsdir2 = m_v.modelsdir(1,mysize);
         m_v.modelsdir = [mymodelsdir1 'models' mymodelsdir2];
      else;
         m_v.modelsdir = getpath(m_v.endofile);
      end;
   end;
   m_v.exo1file = get(out.exogenous1,'String');
   m_v.exo0file = get(out.exogenous0,'String');
   m_v.deterfile = get(out.deterministic,'String');
   m_v.outputfile = get(out.outputfile,'String');
   m_v.cointvalue = get(out.radiocoint,'Value');
   m_v.spectest(1,1) = get(out.serial,'Value');
   m_v.spectest(1,2) = get(out.arch,'Value');
   m_v.spectest(1,3) = get(out.normality,'Value');
   m_v.spectest(1,4) = get(out.constancy,'Value');
   wspectest = num2str(m_v.spectest(1,1));
   wspectest = strcat(wspectest,'$',num2str(m_v.spectest(1,2)));
   wspectest = strcat(wspectest,'$',num2str(m_v.spectest(1,3)));
   wspectest = strcat(wspectest,'$',num2str(m_v.spectest(1,4)));
   m_v.deterselect(1,1) = get(out.uconstant,'Value');
   m_v.deterselect(1,2) = get(out.rconstant,'Value');
   m_v.deterselect(1,3) = get(out.utrend,'Value');
   m_v.deterselect(1,4) = get(out.rtrend,'Value');
   wdeterselect = num2str(m_v.deterselect(1,1));
   wdeterselect = strcat(wdeterselect,'$',num2str(m_v.deterselect(1,2)));
   wdeterselect = strcat(wdeterselect,'$',num2str(m_v.deterselect(1,3)));
   wdeterselect = strcat(wdeterselect,'$',num2str(m_v.deterselect(1,4)));
   m_v.modeltype(1,1) = get(out.structural,'Value');
   m_v.modeltype(1,2) = get(out.reduced,'Value');
   wmodeltype = num2str(m_v.modeltype(1,1));
   wmodeltype = strcat(wmodeltype,'$',num2str(m_v.modeltype(1,2)));
   m_v.seasonal(1,1) = get(out.seasonal,'Value');
   m_v.seasonal(1,2) = get(out.noseasonal,'Value');
   m_v.freq = get(out.seasonal,'UserData');
   wseasonal = num2str(m_v.seasonal(1,1));
   wseasonal = strcat(wseasonal,'$',num2str(m_v.seasonal(1,2)));
   m_v.evars = get(out.endonames,'UserData');
   wevars = strrep(m_v.evars,' ','$');
   m_v.xvars1 = get(out.exo1names,'UserData');
   wxvars1 = strrep(m_v.xvars1,' ','$');
   m_v.xvars0 = get(out.exo0names,'UserData');
   wxvars0 = strrep(m_v.xvars0,' ','$');
   m_v.deter = get(out.deternames,'UserData');
   wdeter = strrep(m_v.deter,' ','$');
   m_v.beginyear = get(out.beginyear,'String');
   m_v.beginyear = strrep(m_v.beginyear,' ','');
   m_v.beginperiod = get(out.beginperiod,'String');
   m_v.beginperiod = strrep(m_v.beginperiod,' ','');
   m_v.endyear = get(out.endyear,'String');
   m_v.endyear = strrep(m_v.endyear,' ','');
   m_v.endperiod = get(out.endperiod,'String');
   m_v.endperiod = strrep(m_v.endperiod,' ','');
   if strcmp(m_v.beginyear,'')==1;
      m_v.beginyear = '-';
   else;
      checkentry = mystr2num(m_v.beginyear);
      if isempty(checkentry)==1;
         m_v.beginyear = '-';
      end;
   end;
   if strcmp(m_v.beginperiod,'')==1;
      m_v.beginperiod = '-';
   else;
      checkentry = mystr2num(m_v.beginperiod);
      if isempty(checkentry)==1;
         m_v.beginperiod = '-';
      end;
   end;
   if strcmp(m_v.endyear,'')==1;
      m_v.endyear = '-';
   else;
      checkentry = mystr2num(m_v.endyear);
      if isempty(checkentry)==1;
         m_v.endyear = '-';
      end;
   end;
   if strcmp(m_v.endperiod,'')==1;
      m_v.endperiod = '-';
   else;
      checkentry = mystr2num(m_v.endperiod);
      if isempty(checkentry)==1;
         m_v.endperiod = '-';
      end;
   end;
   m_v.subbeginyear = get(out.subbeginyear,'String');
   m_v.subbeginyear = strrep(m_v.subbeginyear,' ','');
   m_v.subbeginperiod = get(out.subbeginperiod,'String');
   m_v.subbeginperiod = strrep(m_v.subbeginperiod,' ','');
   m_v.subendyear = get(out.subendyear,'String');
   m_v.subendyear = strrep(m_v.subendyear,' ','');
   m_v.subendperiod = get(out.subendperiod,'String');
   m_v.subendperiod = strrep(m_v.subendperiod,' ','');
   if strcmp(m_v.subbeginyear,'')==1;
      m_v.subbeginyear = '-';
   else;
      checkentry = mystr2num(m_v.subbeginyear);
      if isempty(checkentry)==1;
         m_v.subbeginyear = '-';
      end;
   end;
   if strcmp(m_v.subbeginperiod,'')==1;
      m_v.subbeginperiod = '-';
   else;
      checkentry = mystr2num(m_v.subbeginperiod);
      if isempty(checkentry)==1;
         m_v.subbeginperiod = '-';
      end;
   end;
   if strcmp(m_v.subendyear,'')==1;
      m_v.subendyear = '-';
   else;
      checkentry = mystr2num(m_v.subendyear);
      if isempty(checkentry)==1;
         m_v.subendyear = '-';
      end;
   end;
   if strcmp(m_v.subendperiod,'')==1;
      m_v.subendperiod = '-';
   else;
      checkentry = mystr2num(m_v.subendperiod);
      if isempty(checkentry)==1;
         m_v.subendperiod = '-';
      end;
   end;
   p = m_v.newp;
   h = m_v.newh;
   c = 49+m_v.newc;
   m_v.inputfile = get(out.open,'UserData');
   fid = fopen(m_v.inputfile,'w');
   fprintf(fid,'%s\n',strcat('lag=',int2str(p),'|'));
   fprintf(fid,'%s\n',strcat('horizon=',int2str(h),'|'));
   fprintf(fid,'%s\n',strcat('confidence=',int2str(c),'|'));
   fprintf(fid,'%s\n',strcat('endogenous=',m_v.endofile,'$',strrep(m_v.endosheet,' ','$'),'|'));
   fprintf(fid,'%s\n',strcat('modelsdir=',m_v.modelsdir,'|'));
   fprintf(fid,'%s\n',strcat('exogenous1=',m_v.exo1file,'$',strrep(m_v.exo1sheet,' ','$'),'|'));
   fprintf(fid,'%s\n',strcat('exogenous0=',m_v.exo0file,'$',strrep(m_v.exo0sheet,' ','$'),'|'));
   fprintf(fid,'%s\n',strcat('deterministic=',m_v.deterfile,'$',strrep(m_v.detersheet,' ','$'),'|'));
   fprintf(fid,'%s\n',strcat('outputfile=',m_v.outputfile,'|'));
   fprintf(fid,'%s\n',strcat('cointegration=',int2str(m_v.cointvalue),'|'));
   fprintf(fid,'%s\n',strcat('evars=',wevars,'|'));
   fprintf(fid,'%s\n',strcat('xvars1=',wxvars1,'|'));
   fprintf(fid,'%s\n',strcat('xvars0=',wxvars0,'|'));
   fprintf(fid,'%s\n',strcat('deter=',wdeter,'|'));
   fprintf(fid,'%s\n',strcat('sample=',m_v.beginyear,'$',m_v.beginperiod,'$',m_v.endyear,'$',m_v.endperiod,'|'));
   fprintf(fid,'%s\n',strcat('subsample=',m_v.subbeginyear,'$',m_v.subbeginperiod,'$',m_v.subendyear,'$',m_v.subendperiod,'|'));
   fprintf(fid,'%s\n',strcat('spectest=',wspectest,'|'));
   fprintf(fid,'%s\n',strcat('deterselect=',wdeterselect,'|'));
   fprintf(fid,'%s\n',strcat('modeltype=',wmodeltype,'|'));
   fprintf(fid,'%s\n',strcat('seasonal=',wseasonal,'|'));
   fprintf(fid,'%s\n',strcat('frequency=',m_v.freq,'|'));
   fprintf(fid,'%s\n',strcat('shocks=',strrep(m_v.shocks,' ','$'),'|'));
   fprintf(fid,'%s\n',strcat('lagexo=',int2str(m_v.lagexo),'|'));
   fprintf(fid,'%s\n',strcat('scale=',int2str(m_v.scale_endo),'|'));
   fclose(fid);
   set(out.store,'Enable','off');
   set(out.close,'Enable','on');
   set(out.clear,'Enable','on');
   set(out.savemenu,'Enable','off');
end;

%
% end of main_store_fcn.m
%
