function [m,varnames,dtstr,thissheet,action_sheet] = matread_fcn(filename, arg)

%
% where arg is a sheetname
%

args = nargin;

if nargin==1;
   arg = '';
end;
action = '';
if nargout==5;
   action_sheet = '';
end;

%
% Check the file
%

mat_struc = load(filename);

if isempty(mat_struc)==1;
   m = [];
   varnames = '';
   dtstr = '';
   thissheet = '';
   return;
else;
   if isfield(mat_struc,'sheets')==1;
      sheets = mat_struc.sheets;
      if iscellstr(sheets)==0;
         if ischar(sheets)==1;
            if size(sheets,1)<size(sheets,2);
               fix_sheets = vecstr(sheets);
            else;
               fix_sheets = sheets;
            end;
            for i=1:size(fix_sheets,1);
               new_sheets{i} = strtrim(fix_sheets(i,:));
            end;
            sheets = new_sheets;
         else;
            m = [];
            varnames = '';
            dtstr = '';
            thissheet = '';
            return;
         end;
      end;
      if size(sheets,1)<size(sheets,2);
         sheets = sheets';
      end;
      mat_struc.sheets = sheets;
   else;
      m = [];
      varnames = '';
      dtstr = '';
      thissheet = '';
      return;
   end;
   if nargin==1;
      if size(sheets,1)>1;
         args = 2;
         mysheets = sheets{1};
         for i=2:size(sheets,1);
            mysheets = [mysheets '|' sheets{i}];
         end;
         [action,selsheet] = sheetdlg(mysheets,filename);
         if strcmp(action,'Cancel')==1;
            m = [];
            varnames = '';
            dtstr = '';
            thissheet = '';
            if nargout==5;
               action_sheet = action;
            end;
            return;
         else;
            arg = sheets{selsheet};
         end;
      else;
         arg = mat_struc.sheets{1};
      end;
   end;
end;

if args==1;
   data_struc = getfield(mat_struc,mat_struc.sheets{1});
elseif args==2;
   if strcmp(arg,'')==1;
      data_struc = getfield(mat_struc,mat_struc.sheets{1});
   else;
      data_struc = getfield(mat_struc,arg);
   end;
end;

if isfield(data_struc,'data')==1;
   m = data_struc.data;
else;
   m = [];
   varnames = '';
   dtstr = '';
   thissheet = '';
   return;
end;

varnames = '';
dtstr = '';

if nargout>1;
   if isfield(data_struc,'names')==1;
      varnames = data_struc.names;
      if iscellstr(varnames)==1;
         if size(varnames,1)>size(varnames,2);
            varnames = varnames';
         end;
         out = varnames{1};
         for i=2:size(varnames,2);
            out = [out ' ' varnames{i}];
         end;
         varnames = out;
      end;
   end;
   if isfield(mat_struc,'dates')==1;
      dtstr = mat_struc.dates;
      if iscellstr(dtstr)==1;
%         if size(dtstr,1)<size(dtstr,2);
%            dtstr = dtstr';
%         end;
         out = dtstr{1};
         for i=2:size(dtstr,2);
            out = strvcat(out,dtstr{i});
         end;
         dtstr = out;
      end;
      out = '';
      for i=1:size(dtstr,1);
         dtstri = strtrim(dtstr(i,:));
         dtstri = strrep(dtstri,':',' ');
         dtstri = strrep(dtstri,'-',' ');
         dtstri = strrep(dtstri,'#',' ');
         dtstri = strrep(dtstri,'Q',' ');
         dtstri = strrep(dtstri,'M',' ');
         dtstri = strrep(dtstri,'Y','');
         dtstri = strrep(dtstri,'y','');
         dtstri = strrep(dtstri,'q',' ');
         dtstri = strrep(dtstri,'m',' ');
         dtstri = strrep(dtstri,'@',' ');
         dtstri = strrep(dtstri,'(',' ');
         dtstri = strrep(dtstri,')','');
         dtstri = strrep(dtstri,'[',' ');
         dtstri = strrep(dtstri,']','');
         dtstri = strrep(dtstri,'{',' ');
         dtstri = strrep(dtstri,'}','');
         out = strvcat(out,dtstri);
      end;
      dtstr = out;
   end;
end;

if nargout>=4;
   thissheet = arg;
end;

if nargout==5;
   action_sheet = action;
end;

%
% end of matread_fcn.m
%
