function out = nyblom_moments(n,r,test_type,deter_type)

%
% test_type = max or mean (string)
% deter_type = 1x4 0-1 vector with only one unit element
%

out = [];
if ispc==1;
   file = [pwd '\mat\nyblom-moments.mat'];
elseif isunix==1;
   file = [pwd '/mat/nyblom-moments.mat'];
else;
   return;
end;

a = load(file);
if deter_type==[1 0 0 0];
   %
   % unrestricted constant
   %
   table_name = [test_type '_' num2str(n,'%0.0f') '_' num2str(r,'%0.0f') '_uc'];
elseif deter_type==[0 1 0 0];
   %
   % restricted constant
   %
   table_name = [test_type '_' num2str(n,'%0.0f') '_' num2str(r,'%0.0f') '_rc'];
elseif deter_type==[0 0 1 0];
   %
   % constant+linear trend
   %
   table_name = [test_type '_' num2str(n,'%0.0f') '_' num2str(r,'%0.0f') '_ut'];
elseif deter_type==[0 0 0 1];
   %
   % constant+restricted linear trend
   %
   table_name = [test_type '_' num2str(n,'%0.0f') '_' num2str(r,'%0.0f') '_rt'];
end;

if isfield(a,table_name)==1;
   out = getfield(a,table_name);
else;
   return;
end;

%
% end of nyblom_moments.m
%
