function out = nyblom_pvalues(n,r,test_value,test_type,deter_type)

%
% test_type = max or mean (string)
% deter_type = 1x4 0-1 vector with only one unit element
%

out = [];
if ispc==1;
   file = [pwd '\mat\nyblom.mat'];
elseif isunix==1;
   file = [pwd '/mat/nyblom.mat'];
else;
   return;
end;

a = load(file);
if deter_type==[1 0 0 0];
   %
   % unrestricted constant
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_uc'];
elseif deter_type==[0 1 0 0];
   %
   % restricted constant
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_rc'];
elseif deter_type==[0 0 1 0];
   %
   % constant+linear trend
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_ut'];
elseif deter_type==[0 0 0 1];
   %
   % constant+restricted linear trend
   %
   table_name = [test_type '_asymp_' num2str(n,'%0.0f') '_rt'];
end;

if isfield(a,table_name)==1;
   table = getfield(a,table_name);
else;
   return;
end;

table = table(:,r);
quantiles = quantiles_fcn;
out = zeros(size(test_value,1),1);
for i=1:size(test_value,1);
   for j=1:221;
      if table(j,1)>=test_value(i,1);
         pos = j;
         break;
      end;
      if j==221;
         pos = 222;
      end;
   end;
   y = test_value(i,1);
   if (pos>1)&(pos<222);
      x1 = table(pos-1,1);
      x2 = table(pos,1);
      beta = (y-x1)/(x2-x1);
      z1 = quantiles(pos-1,1);
      z2 = quantiles(pos,1);
      pval = ((1-beta)*z1)+(beta*z2);
      out(i,1) = 1-pval;
   elseif pos==1;
      out(i,1) = 1.0000;
   end;
end;
clear('a');

%
% end of nyblom_pvalues.m
%
