function print_normalitytest(tm,curr_ini,epsilon,beta_df,alpha_df,my_df)

fout = fopen(tm.outputfile,'at');
%
[results3,degfreedom3] = normality(epsilon,tm.T-my_df);
%
if curr_ini.texoutputformat>=2;
   fprintf(fout,['\\subsection*{Normality tests}\n\n\\header{For $r$=' num2str(tm.r) ', lags=' num2str(tm.p) ', \\#free $\\beta$ params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ', \\#free $\\alpha$ params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') '}\n\n']);
   fprintf(fout,'\\header{Wald-type test statistic}\n\n');
   fprintf(fout,'\\begin{tabular}{ll}\n');
   fprintf(fout,'$H_0$: & Standardized residuals have skewness 0 \\\\\n');
   fprintf(fout,'$H_A$: & Standardized residuals are skewed\\\\[2mm]\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,[' & W(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom3(1,:),' ',''),results3(1,1));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results3(1,2));
      fprintf(fout,'$H_0$: & Standardized residuals have kurtosis 3 \\\\\n');
      fprintf(fout,'$H_A$: & Standardized residuals do not have kurtosis 3 \\\\[2mm]\n');
      fprintf(fout,[' & W(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom3(2,:),' ',''),results3(1,3));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results3(1,4));
      fprintf(fout,'$H_0$: & Standardized resisuals have skewness 0 and kurtosis 3 \\\\\n');
      fprintf(fout,'$H_A$: & Standardized residuals are either skewed or do not have kurtosis 3 \\\\[2mm]\n');
      fprintf(fout,[' & W(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom3(3,:),' ',''),results3(1,5));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results3(1,6));
   else;
      fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom3(1,:),' ',''),results3(1,1));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results3(1,2));
      fprintf(fout,'$H_0$: & Standardized residuals have kurtosis 3 \\\\\n');
      fprintf(fout,'$H_A$: & Standardized residuals do not have kurtosis 3 \\\\[2mm]\n');
      fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom3(2,:),' ',''),results3(1,3));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\[3mm]\n'],results3(1,4));
      fprintf(fout,'$H_0$: & Standardized resisuals have skewness 0 and kurtosis 3 \\\\\n');
      fprintf(fout,'$H_A$: & Standardized residuals are either skewed or do not have kurtosis 3 \\\\[2mm]\n');
      fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],strrep(degfreedom3(3,:),' ',''),results3(1,5));
      fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results3(1,6));
   end;
   fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
else;
   fprintf(fout,['NORMALITY TESTS\n\n(for rank=' num2str(tm.r) ',lags=' num2str(tm.p) ',#free beta params=' num2str(tm.r*(tm.n-tm.r)-beta_df,'%0.0f') ',#free alpha params=' num2str(tm.n*tm.r-alpha_df,'%0.0f') ') \n\n']);
   fprintf(fout,'  Wald-type test statistic\n');
   fprintf(fout,'  ~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
   fprintf(fout,'Null hypothesis:        Standardized residuals have skewness 0\n');
   fprintf(fout,'Alternative hypothesis: Standardized residuals are skewed\n\n');
   if curr_ini.sscorrect==0;
      fprintf(fout,['W(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],strrep(degfreedom3(1,:),' ',''),results3(1,1));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results3(1,2));
      fprintf(fout,'\n   ------------------------\n\n');
      fprintf(fout,'Null hypothesis:        Standardized residuals have kurtosis 3\n');
      fprintf(fout,'Alternative hypothesis: Standardized residuals do not have kurtosis 3\n\n');
      fprintf(fout,['W(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],strrep(degfreedom3(2,:),' ',''),results3(1,3));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results3(1,4));
      fprintf(fout,'\n   ------------------------\n\n');
      fprintf(fout,'Null hypothesis:        Standardized resisuals have skewness 0\n');
      fprintf(fout,'                        and kurtosis 3\n');
      fprintf(fout,'Alternative hypothesis: Standardized residuals are either skewed or\n');
      fprintf(fout,'                        do not have kurtosis 3\n\n');
      fprintf(fout,['W(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],strrep(degfreedom3(3,:),' ',''),results3(1,5));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results3(1,6));
   else;
      fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],strrep(degfreedom3(1,:),' ',''),results3(1,1));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results3(1,2));
      fprintf(fout,'\n   ------------------------\n\n');
      fprintf(fout,'Null hypothesis:        Standardized residuals have kurtosis 3\n');
      fprintf(fout,'Alternative hypothesis: Standardized residuals do not have kurtosis 3\n\n');
      fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],strrep(degfreedom3(2,:),' ',''),results3(1,3));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results3(1,4));
      fprintf(fout,'\n   ------------------------\n\n');
      fprintf(fout,'Null hypothesis:        Standardized resisuals have skewness 0\n');
      fprintf(fout,'                        and kurtosis 3\n');
      fprintf(fout,'Alternative hypothesis: Standardized residuals are either skewed or\n');
      fprintf(fout,'                        do not have kurtosis 3\n\n');
      fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],strrep(degfreedom3(3,:),' ',''),results3(1,5));
      fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results3(1,6));
   end;
   fprintf(fout,'\n===============================================================================\n\n');
end;
if curr_ini.omnibus==1;
   [results4,degfreedom4] = omnibus_fcn(epsilon,tm.T-my_df);
   if curr_ini.texoutputformat>=2;
      fprintf(fout,'\\header{Shenton-Bowman \\& Doornik-Hansen Omnibus-type test}\n\n');
      fprintf(fout,'\\begin{tabular}{ll}\n');
      fprintf(fout,'$H_0$: & Standardized resisuals have skewness 0 and kurtosis 3 \\\\\n');
      fprintf(fout,'$H_A$: & Standardized residuals are either skewed or do not have kurtosis 3 \\\\[2mm]\n');
      if curr_ini.sscorrect==0;
         fprintf(fout,[' & $\\mbox{\\rm E}_%0.0f(%s)$ = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],tm.n,degfreedom4,results4(1,1));
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results4(1,2));
      else;
         fprintf(fout,[' & F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f  (based on $\\mbox{\\rm E}_%0.0f$) \\\\\n'],degfreedom4,results4(1,1),tm.n);
         fprintf(fout,[' & $p$-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \\\\\n'],results4(1,2));
      end;
      fprintf(fout,'\\end{tabular}\n\n\\ruler\n\n%%==============================================================================\n\n');
   else;
      fprintf(fout,'   Shenton-Bowman/Doornik-Hansen Omnibus-type test\n');
      fprintf(fout,'   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n');
      fprintf(fout,'Null hypothesis:        Standardized resisuals have skewness 0\n');
      fprintf(fout,'                        and kurtosis 3\n');
      fprintf(fout,'Alternative hypothesis: Standardized residuals are either skewed or\n');
      fprintf(fout,'                        do not have kurtosis 3\n\n');
      if curr_ini.sscorrect==0;
         fprintf(fout,['E_%0.0f(%s) = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],tm.n,degfreedom4,results4(1,1));
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results4(1,2));
      else;
         fprintf(fout,['F%s = %0.' num2str(curr_ini.decimals,'%0.0f') 'f       (based on E_%0.0f) \n'],degfreedom4,results4(1,1),tm.n);
         fprintf(fout,['p-value = %0.' num2str(curr_ini.decimals,'%0.0f') 'f \n'],results4(1,2));
      end;
      fprintf(fout,'\n===============================================================================\n\n');
   end;
end;
fclose(fout);

%
% end of print_normalitytest.m
%
