function new_leg = resize_legend_fcn(legh,base_axes)

ud = get(legh,'UserData');
this_axes = ud.PlotHandle;

h = get(base_axes,'Parent');
if iscompiled==1;
   toolbar = get(h,'UserData');
   my_fonts = get(toolbar.new,'UserData');
else;
   ax_par = get(base_axes,'UserData');
   if isempty(ax_par)==0;
      if isstruct(ax_par)==1;
         my_fonts = ax_par;
      else;
         my_fonts = [];
      end;
   else;
      my_fonts = [];
   end;
end;

%
% check if old legend font has changed
%

if isempty(my_fonts)==1;
   new_leg = legh;
   return;
else;
   myfonts = my_fonts;
   num_parents = size(myfonts.parent,2);
   fontpos = 0;
   for i=1:num_parents;
      if myfonts.parent(i)==base_axes;
         fontpos = i;
         break;
      end;
   end;
   if fontpos==0;
      new_leg = legh;
      return;
   end;
end;

newfonts.font(1).fontname = myfonts.font(fontpos).fontname;
newfonts.font(1).fontsize = myfonts.font(fontpos).fontsize;
newfonts.font(1).fontangle = myfonts.font(fontpos).fontangle;
newfonts.font(1).fontweight = myfonts.font(fontpos).fontweight;
newfonts.font(1).fontunits = myfonts.font(fontpos).fontunits;
newfonts.parent(1) = this_axes;

set(this_axes,'UserData',newfonts);

old_color = get(legh,'Color');
old_border_color = get(legh,'XColor');
text_strings = findobj(legh,'Type','text')';
if isempty(text_strings)==0;
   text_obj.color = get(text_strings(1,1),'Color');
end;

%
% updating the legend
%

new_leg = update_legend(legh);

%
% making sure all colors match
%

set(new_leg,'Color',old_color,'XColor',old_border_color,'YColor',old_border_color);
new_text_strings = findobj(new_leg,'Type','text')';
if isempty(new_text_strings)==0;
   for i=1:size(new_text_strings,2);
      set(new_text_strings(1,i),'Color',text_obj.color);
   end;
end;

%
% end of resize_legend_fcn.m
%
