function show_corrtest(fig_handle,tm,curr_ini,ind)

set(fig_handle,'Visible','off');
drawnow;
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
realscrsz = get(0,'ScreenSize');
%[results1,degfreedom1] = autocorr(tm.epsilon,tm.freq,tm.T-tm.df);
[results1,degfreedom1] = lmautocorr(tm.epsilon,tm.Z0,tm.Z1,tm.Z2,tm.beta(:,1:tm.r),tm.freq,tm.T-tm.df);
%
prt_val = ['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
%
corrtext = strvcat(' ',['SERIAL CORRELATION TESTS (for' res_str ' rank=' num2str(tm.r) ')']);
numchar = size(corrtext,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
corrtext = strvcat(corrtext,addcorr,' ');
corrtext = strvcat(corrtext,'  LM-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~',' ','Null hypothesis:        residuals are serially uncorrelated','Alternative hypothesis: residuals follow VAR(1)',' ');
if curr_ini.sscorrect==0;
   corrtext = strvcat(corrtext,['LM(' degfreedom1(1,:) ') = ' num2str(results1(1,1),prt_val)]);
   if strcmp(tm.freq,'')==1;
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,2),prt_val)]);
   elseif strcmp(tm.freq,'q');
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,2),prt_val)]);
      corrtext = strvcat(corrtext,' ','Null hypothesis:        residuals are serially uncorrelated','Alternative hypothesis: residuals follow VAR at lag 4',' ');
      corrtext = strvcat(corrtext,['LM(' strrep(degfreedom1(2,:),' ','') ') = ' num2str(results1(1,3),prt_val)]);
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,4),prt_val)]);
   else;
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,2),prt_val)]);
      corrtext = strvcat(corrtext,' ','Null hypothesis:        residuals are serially uncorrelated','Alternative hypothesis: residuals follow VAR at lag 12',' ');
      corrtext = strvcat(corrtext,['LM(' strrep(degfreedom1(2,:),' ','') ') = ' num2str(results1(1,3),prt_val)]);
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,4),prt_val)]);
   end;
else;
   corrtext = strvcat(corrtext,['F' degfreedom1(1,:) ' = ' num2str(results1(1,1),prt_val)]);
   if strcmp(tm.freq,'')==1;
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,2),prt_val)]);
   elseif strcmp(tm.freq,'q');
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,2),prt_val)]);
      corrtext = strvcat(corrtext,' ','Null hypothesis:        residuals are serially uncorrelated','Alternative hypothesis: residuals follow VAR at lag 4',' ');
      corrtext = strvcat(corrtext,['F' strrep(degfreedom1(2,:),' ','') ' = ' num2str(results1(1,3),prt_val)]);
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,4),prt_val)]);
   else;
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,2),prt_val)]);
      corrtext = strvcat(corrtext,' ','Null hypothesis:        residuals are serially uncorrelated','Alternative hypothesis: residuals follow VAR at lag 12',' ');
      corrtext = strvcat(corrtext,['F' strrep(degfreedom1(2,:),' ','') ' = ' num2str(results1(1,3),prt_val)]);
      corrtext = strvcat(corrtext,['p-value = ' num2str(results1(1,4),prt_val)]);
   end;
end;
if curr_ini.portmanteau==1;
   [results2,degfreedom2] = portmanteau_fcn(tm.epsilon,tm.p,tm);
   addcorr = '';
   numchar = size(corrtext,2);
   for i=1:numchar+2;
      addcorr=[addcorr '-'];
   end;
   corrtext = strvcat(corrtext,' ',addcorr,' ');
   corrtext = strvcat(corrtext,'  Ljung-Box-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~',' ');
   corrtext = strvcat(corrtext,'Null hypothesis:        residuals are serially uncorrelated',['Alternative hypothesis: ' strrep(degfreedom2(2,:),' ','') 'th order residual correlation'],' ');
   corrtext = strvcat(corrtext,['LB(' strrep(degfreedom2(1,:),' ','') ') = ' num2str(results2(1,1),prt_val)]);
   corrtext = strvcat(corrtext,['p-value = ' num2str(results2(1,2),prt_val)]);
end;
corrtext = strvcat(corrtext,' ');
corrtext = aligntxt(corrtext);
textgui(corrtext,'Serial Correlation Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_corrtest.m
%
