function out = trace_pvalue_exo(nr,q1,trace_test,type_var)

%
% nr: number of endogenous variables-number of cointegration relations
% q1: number of exogenous I(1) variables
% trace_test: Tx1 vector of trace tests for r0<=r
% type_var: deterministic model type
%

num = size(trace_test,1);
out = zeros(num,1);
if ispc==1;
   file = [pwd '\mat\trace.mat'];
else;
   file = [pwd '/mat/trace.mat'];
end;
if fileexist(file)==1;
   a = load(file);
else;
   return;
end;
if type_var==[0 1 0 0];
   %
   % restricted constant
   %
   table = getfield(a,['trace_12_' num2str(q1,'%0.0f') '_rc']);
elseif type_var==[0 0 0 1];
   %
   % constant+restricted linear trend
   %
   table = getfield(a,['trace_12_' num2str(q1,'%0.0f') '_rt']);
else;
   return;
end;

quantiles = quantiles_fcn;
trace_table = table(:,nr);

%
% find first value greater than trace-tests
%

for i=1:num;
   for j=1:221;
      if trace_table(j,1)>=trace_test(i,1);
         pos = j;
         break;
      end;
      if j==221;
         pos = 222;
      end;
   end;
   y = trace_test(i,1);
   if (pos>1)&(pos<222);
      x1 = trace_table(pos-1,1);
      x2 = trace_table(pos,1);
      beta = (y-x1)/(x2-x1);
      z1 = quantiles(pos-1,1);
      z2 = quantiles(pos,1);
      pval = ((1-beta)*z1)+(beta*z2);
      out(i,1) = 1-pval;
   elseif pos==1;
      out(i,1) = 1.0000;
   end;
end;

%
% end of trace_pvalue_exo.m
%
