function outvec = tracepval_exo(n,q1,trace_test,type_var)

%
% n = dimension
% q1 = number of exogenous I(1) variables
% trace_test = trace-tests
% type_var = distribution
%
% Critical values simulated with Structural VAR using sample size of 1000
% and 100,000 replications
%

outvec = [];
if ispc==1;
   file = [pwd '\mat\trace.mat'];
else;
   file = [pwd '/mat/trace.mat'];
end;
if fileexist(file)==1;
   a = load(file);
else;
   return;
end;
if type_var==[0 1 0 0];
   %
   % restricted constant
   %
   table = getfield(a,['trace_12_' num2str(q1,'%0.0f') '_rc']);
elseif type_var==[0 0 0 1];
   %
   % constant+restricted linear trend
   %
   table = getfield(a,['trace_12_' num2str(q1,'%0.0f') '_rt']);
else;
   return;
end;

quantiles = quantiles_fcn;
table = table(:,1:n);

%
% find first value greater than trace-tests
%

pos = [];
for i=1:n;
   for j=1:221;
      if table(j,n-i+1)>=trace_test(i,1);
         pos = [pos;j];
         break;
      end;
      if j==221;
         pos = [pos;222];
      end;
   end;
end;

for i=1:n;
   y = trace_test(i,1);
   posi = pos(i,1);
   if (posi>1)&(posi<222);
      x1 = table(posi-1,n-i+1);
      x2 = table(posi,n-i+1);
      beta = (y-x1)/(x2-x1);
      z1 = quantiles(posi-1,1);
      z2 = quantiles(posi,1);
      pval = ((1-beta)*z1)+(beta*z2);
      outvec = [outvec;(1-pval)];
   elseif posi==1;
      outvec = [outvec;1.0000];
   elseif posi==222;
      outvec = [outvec;0.0000];
   end;
end;

%
% end of tracepval_exo.m
%
