function [] = var(varargin)

%
% input function for running Structural VAR. Supports command line
% options. Run var('-h') to check out which ones are available.
%

warning('off');
drawnow;

old_units = get(0,'Units');
if strcmp(get(0,'Units'),'pixels')==0;
   set(0,'Units','pixels');
end;

if nargin>0;
   file = '';
   my_text = '';
   show_help = 0;
   show_version = 0;
   beg_run = 0;
   show_fig = 0;
   this_inputfile = '';
   i=1;
   while i<=size(varargin,2);
      %
      % check the input arguments
      %
      check_txt = varargin{i};
%      check_txt = strrep(check_txt,'''','');
      if ischar(check_txt)==1;
         check_txt = strtrim(check_txt);
         check_txtbeg = check_txt(1,1);
      else;
         check_txt = num2str(check_txt);
         check_txtbeg = '-';
      end;
      if (strcmp(check_txt,'-h')==1)|(strcmp(check_txt,'--help')==1)|(strcmp(check_txt,'-?')==1);
         show_help = 1;
      elseif (strcmp(check_txt,'-v')==1)|(strcmp(check_txt,'--version')==1);
         show_version = 1;
      elseif (strcmp(check_txt,'-f')==1)|(strcmp(check_txt,'--figure')==1);
         show_fig = 1;
      elseif (strcmp(check_txt,'-r')==1)|(strcmp(check_txt,'--run')==1);
         beg_run = 1;
      elseif strcmp(check_txt,'-d')==1;
         if i<size(varargin,2);
            new_dir = varargin{i+1};
            if ischar(new_dir)==1;
               %
               % adjust for spaces in paths
               %
               check_space = findstr(new_dir,'''');
               if (isempty(check_space)==0)&(size(check_space,2)==1);
                  inc_dir = 0;
                  while inc_dir==0;
                     if size(varargin,2)>=i+1;
                        add_dir = varargin{i+1};
                        i = i+1;
                        new_dir = [new_dir ' ' add_dir];
                        ch_space = findstr(add_dir,'''');
                        if isempty(ch_space)==0;
                           inc_dir = 1;
                        end;
                     else;
                        inc_dir = 1;
                     end;
                  end;
               else;
                  check_space = findstr(new_dir,'"');
                  if isempty(check_space)==0;
                     inc_dir = 0;
                     while inc_dir==0;
                        if size(varargin,2)>=i+1;
                           add_dir = varargin{i+1};
                           i = i+1;
                           new_dir = [new_dir ' ' add_dir];
                           ch_space = findstr(add_dir,'"');
                           if isempty(ch_space)==0;
                              inc_dir = 1;
                           end;
                        else;
                           inc_dir = 1;
                        end;
                     end;
                  end;
               end;
               new_dir = strrep(new_dir,'''','');
               new_dir = strrep(new_dir,'"','');
               %
               % check if var exists there
               %
               var_str = new_dir;
               if ispc==1;
                  if strcmp(new_dir(1,size(var_str,2)),'\')==0;
                     var_str = [var_str '\'];
                  else;
                     new_dir = new_dir(1,1:size(new_dir,2)-1);
                  end;
               else;
                  if isunix==1;
                     var_str = [var_str '/'];
                  else;
                     if strcmp(new_dir(1,size(var_str,2)),'/')==0;
                        var_str = [var_str '/'];
                     else;
                        new_dir = new_dir(1,1:size(new_dir,2)-1);
                     end;
                  end;
               end;
               if iscompiled==1;
                  var_exe = [var_str 'var.exe'];
                  if appexist(var_exe)==1;
                     cd(new_dir);
                  else;
                     my_text = strvcat(' ',['Invalid directory: ' new_dir]);
                     show_help = 1;
                     break;
                  end;
               else;
                  var_m = [var_str 'var.m'];
                  if fileexist(var_m)==1;
                     cd(new_dir);
                  else;
                     my_text = strvcat(' ',['Invalid directory: ' new_dir]);
                     show_help = 1;
                     break;
                  end;
               end;
            end;
            i = i+1;
         end;
      elseif (strcmp(check_txtbeg,'-')==1)|(strcmp(check_txtbeg,'\')==1)|(strcmp(check_txtbeg,'_')==1)|(strcmp(check_txtbeg,'.')==1)|(strcmp(check_txtbeg,':')==1)|((isletter(check_txtbeg)==0)&(strcmp(check_txtbeg,'/')==0)&(strcmp(check_txtbeg,'''')==0)&(strcmp(check_txtbeg,'"')==0));
         if size(check_txt,2)>=6
            if (strcmp(check_txt(1,1:3),'-d=')==1)|(strcmp(check_txt(1,1:6),'--dir=')==1);
               eq_pos = findstr(check_txt,'=');
               eq_pos = eq_pos(1,1)+1;
               new_dir = check_txt(1,eq_pos:size(check_txt,2));
               %
               % adjust for spaces in paths
               %
               check_space = findstr(new_dir,'''');
               if (isempty(check_space)==0)&(size(check_space,2)==1);
                  inc_dir = 0;
                  while inc_dir==0;
                     if size(varargin,2)>=i+1;
                        add_dir = varargin{i+1};
                        i = i+1;
                        new_dir = [new_dir ' ' add_dir];
                        ch_space = findstr(add_dir,'''');
                        if isempty(ch_space)==0;
                           inc_dir = 1;
                        end;
                     else;
                        inc_dir = 1;
                     end;
                  end;
               else;
                  check_space = findstr(new_dir,'"');
                  if isempty(check_space)==0;
                     inc_dir = 0;
                     while inc_dir==0;
                        if size(varargin,2)>=i+1;
                           add_dir = varargin{i+1};
                           i = i+1;
                           new_dir = [new_dir ' ' add_dir];
                           ch_space = findstr(add_dir,'"');
                           if isempty(ch_space)==0;
                              inc_dir = 1;
                           end;
                        else;
                           inc_dir = 1;
                        end;
                     end;
                  end;
               end;
               new_dir = strrep(new_dir,'''','');
               new_dir = strrep(new_dir,'"','');
               %
               % check if var exists there
               %
               var_str = new_dir;
               if ispc==1;
                  if strcmp(new_dir(1,size(var_str,2)),'\')==0;
                     var_str = [var_str '\'];
                  else;
                     new_dir = new_dir(1,1:size(new_dir,2)-1);
                  end;
               else;
                  if isunix==1;
                     var_str = [var_str '/'];
                  else;
                     if strcmp(new_dir(1,size(var_str,2)),'/')==0;
                        var_str = [var_str '/'];
                     else;
                        new_dir = new_dir(1,1:size(new_dir,2)-1);
                     end;
                  end;
               end;
               if iscompiled==1;
                  var_exe = [var_str 'var.exe'];
                  if appexist(var_exe)==1;
                     cd(new_dir);
                  else;
                     my_text = strvcat(' ',['Invalid directory: ' new_dir]);
                     show_help = 1;
                     break;
                  end;
               else;
                  var_m = [var_str 'var.m'];
                  if fileexist(var_m)==1;
                     cd(new_dir);
                  else;
                     my_text = strvcat(' ',['Invalid directory: ' new_dir]);
                     show_help = 1;
                     break;
                  end;
               end;
            else;
               my_text = strvcat(' ',['Unknown option: ' check_txt]);
               show_help = 1;
               break;
            end;
         else;
            my_text = strvcat(' ',['Unknown option: ' check_txt]);
            show_help = 1;
            break;
         end;
      else;
         %
         % adjust for spaces in paths+filename
         %
         check_space = findstr(check_txt,'''');
         if (isempty(check_space)==0)&(size(check_space,2)==1);
            inc_dir = 0;
            while inc_dir==0;
               if size(varargin,2)>=i+1;
                  add_dir = varargin{i+1};
                  i = i+1;
                  check_txt = [check_txt ' ' add_dir];
                  ch_space = findstr(add_dir,'''');
                  if isempty(ch_space)==0;
                     inc_dir = 1;
                  end;
               else;
                  inc_dir = 1;
               end;
            end;
         else;
            check_space = findstr(check_txt,'"');
            if isempty(check_space)==0;
               inc_dir = 0;
               while inc_dir==0;
                  if size(varargin,2)>=i+1;
                     add_dir = varargin{i+1};
                     i = i+1;
                     check_txt = [check_txt ' ' add_dir];
                     ch_space = findstr(add_dir,'"');
                     if isempty(ch_space)==0;
                        inc_dir = 1;
                     end;
                  else;
                     inc_dir = 1;
                  end;
               end;
            end;
         end;
         check_txt = strrep(check_txt,'''','');
         check_txt = strrep(check_txt,'"','');
         %
         % file exists checking
         %
         my_ext = lower(getext(check_txt));
         if strcmp(my_ext,'.var')==1;
            if fileexist(check_txt)==1;
               mod_file = readtext(check_txt);
               if size(mod_file,2)>=21;
                  file = check_txt;
               else;
                  beg_run = 0;
                  file = 'init';
               end;
            else;
               beg_run = 0;
               file = 'init';
            end;
         elseif strcmp(my_ext,'.fig')==1;
            if fileexist(check_txt)==1;
               beg_run = 0;
               show_fig = 1;
               file = check_txt;
            end;
         else;
            beg_run = 0;
            file = 'init';
         end;
      end;
      i = i+1;
   end;
   if beg_run==1;
      if strcmp(file,'')==1;
         file = 'init';
         beg_run = 0;
      end;
   end;
   if show_fig==1;
      if strcmp(file,'')==1;
         file = 'figure';
         beg_run = 0;
      elseif strcmp(lower(getext(file)),'.var')==1;
         show_fig = 0;
      else;
         beg_run = 0;
      end;
   end;
   if show_version==1;
      my_text = strvcat(my_text,' ',['Structural VAR, version ' num2str(myvers,'%0.2f') ', release ' num2str(myrelease,'%0.0f')],['Copyright  2001-' datestr(now,10) ' Anders Warne'],' ',['Web site: ' var_homepage],['Email:    ' var_email]);
      if show_help==0;
         realscrsz = get(0,'ScreenSize');
         textgui(my_text,'Structural VAR',[(realscrsz(3)-525)/2 (realscrsz(4)-210)/2 525 200],'Version Information',90,0);
         return;
      end;
   end;
   if show_help==1;
      help_text = strvcat(' ','Command line: var [options] [inputfile]',' ','where the inputfile must have the extension ''var'' or ''fig''.');
      help_text = strvcat(help_text,' ','Options:',...
         ' ', ...
         '   -d DIR, --dir=DIR   Directory where Structural VAR is located.', ...
         '   -f, --figure        Run Structural VAR in Matlab fig viewing', ...
         '                       mode (not necessary if the inputfile has', ...
         '                       the extension ''fig'').', ...
         '   -h, --help, -?      Show this help screen and exits.', ...
         '   -r, --run           Begin estimation with inputfile', ...
         '                       (requires a valid ''var'' inputfile).', ...
         '   -v, --version       Show current version number and exits.');
      if strcmp(my_text,'')==1;
         add = 0;
         my_text = help_text;
      else;
         add = 130;
         my_text = strvcat(my_text,' ','*****************************************************************',help_text);
      end;
      realscrsz = get(0,'ScreenSize');
      textgui(my_text,'Structural VAR',[(realscrsz(3)-580)/2 (realscrsz(4)-(300+add))/2 580 340+add],'Help Information',80,0);
      return;
   end;
   if isempty(file)==0;
      if beg_run==0;
         if show_fig==1;
            set(0,'DefaultFigureIntegerHandle','on');
         end;
         maingui = runmaindlg_fcn(file);
      else;
         maingui = runmaindlg_fcn(file,'--run');
      end;
   else;
      maingui = runmaindlg_fcn('init');
   end;
else;
   maingui = runmaindlg_fcn('init');
   show_fig = 0;
end;

%
% check if "svar-version.txt" exists and delete it if necessary
%

if fileexist('svar-version.txt')==1;
   delete_file_fcn('svar-version.txt');
end;
if fileexist('download.log')==1;
   delete_file_fcn('download.log');
end;

model = get(maingui,'UserData');
if isempty(model)==0;
   if strcmp(get(model.leave,'UserData'),'done')==1;
      delete(maingui);
   end;
end;

var_ini = initialize_inifile;
fixvarini(size(fieldnames(var_ini),1));
[read_status,var_ini] = read_inifile;
if read_status==1;
   var_ini = initialize_inifile;
end;

if iscompiled==1;
   num = 0;
   del_done = 0;
   while del_done==0;
      fig_file = [var_ini.tempdir 'tempfile-' num2str(num) '.fig'];
      if fileexist(fig_file)==1;
         delete_file_fcn(fig_file);
         num = num+1;
      else;
         del_done = 1;
      end;
   end;
end;

if (iswinnt==1)&(iscompiled==1);
   %
   % just incase there are any instances of seticon running we try to shut them
   % all down
   %
   if show_fig==0;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\killicon.exe'])];
      dos(prog);
   end;
   delete_file_fcn([var_ini.tempdir 'pid.txt']);
   delete_file_fcn([var_ini.tempdir 'killpid.txt']);
end;

if (var_ini.openvar==1)&(iscompiled==0);
   myquit;
end;

if strcmp(old_units,'pixels')==0;
   set(0,'Units',old_units);
end;

%
% end of var.m
%
