function view_graphics_fcn(graphfile)

curr_ini = find_inisettings;

if nargin==0;
   figuredir = pwd;
   if ispc==1;
      figuredir = [figuredir '\'];
   else;
      figuredir = [figuredir '/'];
   end;
   mainfig = findobj('Tag','StructuralVAR')';
   if isempty(mainfig)==0;
      if ishandle(mainfig)==1;
         model = get(mainfig,'UserData');
         new_figuredir = get(model.outputfile,'String');
         new_figuredir = strtrim(new_figuredir);
         new_figuredir = getpath(new_figuredir);
         if strcmp(new_figuredir,'')==0;
            figuredir = new_figuredir;
         end;
      end;
   end;
   %
   % setting default file types
   %
   if matlabnumber>=6.0;
      file = cell(18,2);
      num = 0;
      num = 1;
      file = {'*.fig', 'VAR Figure Files (*.fig)'};
      if strcmp(curr_ini.aiviewer,'')==0;
         file{num+1,1} = '*.ai';
         file{num+1,2} = 'Adobe Illustrator Files (*.ai)';
         num = num+1;
      end;
      if strcmp(curr_ini.epsviewer,'')==0;
         file{num+1,1} = '*.eps';
         file{num+1,2} = 'Encapsulated PostScript Files (*.eps)';
         file{num+2,1} = '*.ps';
         file{num+2,2} = 'PostScript Files (*.ps)';
         file{num+3,1} = '*.pdf';
         file{num+3,2} = 'Portable Document Format Files (*.pdf)';
         num = num+3;
      elseif strcmp(curr_ini.pdfviewer,'')==0;
         file{num+1,1} = '*.pdf';
         file{num+1,2} = 'Portable Document Format Files (*.pdf)';
         num = num+1;
      end;
      if strcmp(curr_ini.bitmapviewer,'')==0;
         file{num+1,1} = '*.emf;*.wmf';
         file{num+1,2} = 'Windows Metafiles (*.emf, *.wmf)';
         file{num+2,1} = '*.jpg;*.jpeg';
         file{num+2,2} = 'JPEG Files (*.jpg, *.jpeg)';
         file{num+3,1} = '*.tif;*.tiff';
         file{num+3,2} = 'Tagged Image Format Files (*.tif, *.tiff)';
         file{num+4,1} = '*.png';
         file{num+4,2} = 'Portable Network Graphics (*.png)';
         file{num+5,1} = '*.bmp';
         file{num+5,2} = 'Windows Bitmap Files (*.bmp)';
         file{num+6,1} = '*.pcx';
         file{num+6,2} = 'Paintbrush 24-bit Files (*.pcx)';
         file{num+7,1} = '*.pbm';
         file{num+7,2} = 'Portable Bitmap Files (*.pbm)';
         file{num+8,1} = '*.pgm';
         file{num+8,2} = 'Portable Graymap Files (*.pgm)';
         file{num+9,1} = '*.ppm';
         file{num+9,2} = 'Portable Pixmap Files (*.ppm)';
         num = num+9;
      end;
      if num>0;
         file = file(1:num,:);
      end;
   else;
      if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1);
         basedir = figuredir;
         file_fltr = 'VAR Figure Files (*.fig)|*.fig|';
         all_grf = '*.fig';
         if strcmp(curr_ini.aiviewer,'')==0;
            if strcmp(curr_ini.epsviewer,'')==1;
               file_fltr = [file_fltr 'Adobe Illustrator Files (*.ai)|*.ai|'];
            end;
         end;
         if strcmp(curr_ini.epsviewer,'')==0;
            if strcmp(curr_ini.aiviewer,'')==0;
               file_fltr = [file_fltr 'PostScript Files (*.ai, *.eps, *.ps)|*.ai;*.eps;*.ps|'];
            else;
               file_fltr = [file_fltr 'PostScript Files (*.eps, *.ps)|*.eps;*.ps|'];
            end;
            all_grf = [all_grf ';*.eps;*.ps;*.pdf'];
         elseif strcmp(curr_ini.pdfviewer,'')==0;
            file_fltr = [file_fltr 'Portable Document Format Files (*.pdf)|*.pdf|'];
            all_grf = [all_grf ';*.pdf'];
         end;
         if strcmp(curr_ini.bitmapviewer,'')==0;
            all_grf = [all_grf ';*.wmf;*.jpg;*.png;*.bmp'];
         end;
         if size(findstr(all_grf,'*'),2)>1;
            file_fltr = ['Graphics Files|' all_grf '|' file_fltr];
         end;
         file_fltr = [file_fltr 'All Files (*.*)|*.*|'];
         best_pos = 1;
         title_txt = 'Open';
      else;
         grfmt = '*.fig';
         if strcmp(curr_ini.epsviewer,'')==0;
            grfmt = [grfmt ';*.eps;*.ps;*.pdf'];
         elseif strcmp(curr_ini.pdfviewer,'')==0;
            grfmt = [grfmt ';*.pdf'];
         end;
         if strcmp(curr_ini.bitmapviewer,'')==0;
            grfmt = [grfmt ';*.wmf;*.jpg;*.png;*.bmp'];
         end;
         file = [figuredir grfmt];
      end;
   end;
   if (iscompiled==1)&(iswinnt==1)&(curr_ini.opendialog==1)&(matlabnumber<6.0);
      [graphfile,graphpath] = fileopen(basedir,file_fltr,best_pos,title_txt);
   else;
      if matlabnumber>=6;
         [graphfile,graphpath] = uigetfile(file, 'Open',figuredir);
      else;
         [graphfile,graphpath] = uigetfile(file, 'Open');
      end;
   end;
   drawnow;
   if isnumeric(graphfile)==0;
      graphfile = strcat(graphpath,graphfile);
      graphext = getext(graphfile);
      if (strcmp(graphext,'.eps')==1)|(strcmp(graphext,'.ps')==1)|(strcmp(graphext,'.pdf')==1);
         graphviewer = curr_ini.epsviewer;
         if (strcmp(curr_ini.pdfviewer,'')==0)&(strcmp(graphext,'.pdf')==1);
            graphviewer = curr_ini.pdfviewer;
         end;
      elseif strcmp(graphext,'.ai')==1;
         graphviewer = curr_ini.aiviewer;
      elseif strcmp(graphext,'.fig')==1;
         graphviewer = 'matlab';
      else;
         graphviewer = curr_ini.bitmapviewer;
      end;
      if strcmp(graphviewer,'')==0;
         if strcmp(graphviewer,'matlab')==0;
            prog = [fix_filepath(graphviewer) ' ' fix_filepath(graphfile) ' &'];
            if ispc==1;
               prog = fixcmd(prog);
               dos(prog);
               maximize_prog(graphfile,graphviewer);
            else;
               if isunix==1;
                  unix(prog);
               else;
                  txt = 'Currently Structural VAR cannot run programs under Mac. If you know of a technique for such systems, please let know.';
                  txt = strvcat(txt,' ',['Email: ' var_email]);
                  about(txt,'warning','View Graphics File - Mac',135,350);
               end;
            end;
         else;
            openfig_fcn(graphfile);
         end;
      else;
         txt = ['The graphics format "' graphext '" is not supported by any viewer that Structural VAR has been informed about. Please check the Preferences Dialog under the External tab.'];
         about(txt,'warning','Unsupported viewer format...',120,350);
      end;
   end;
end;

%
% end of view_graphics_fcn.m
%
